unit fmOutput;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables,Placemnt, Mask, ToolEdit, RXLookup, StdCtrls, Db,
  DBLists,clipbrd, ComCtrls;

type
  TfrmMain = class(TForm)
    FormStorage1: TFormStorage;
    Database1: TDatabase;
    BDEItems1: TBDEItems;
    DataSource1: TDataSource;
    btnOK: TButton;
    btnCancel: TButton;
    Query1: TQuery;
    PageControl1: TPageControl;
    tabMain: TTabSheet;
    edtPass: TEdit;
    Label2: TLabel;
    edtUser: TEdit;
    Label1: TLabel;
    cboAlias: TRxLookupEdit;
    Label3: TLabel;
    tabConfiguration: TTabSheet;
    Label4: TLabel;
    edtEditor: TFilenameEdit;
    Label5: TLabel;
    edtDelimiter: TEdit;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  hDBExplorer: HWnd;

implementation

{$R *.DFM}

procedure TfrmMain.btnCancelClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.btnOKClick(Sender: TObject);
const
  BufSize = 2047;
var
  Buf: Array[0..BufSize] of char;
  List: TStrings;
  x: Integer;
  Str1: String;
begin
  try
    Screen.Cursor:= crHourglass;
    With Database1 do begin
      Params.Clear;
      AliasName:=cboAlias.Text;
      Params.Add(Format('USER NAME=%s',[edtUser.Text]));
      Params.Add(Format('PASSWORD=%s',[edtPass.Text]));
      Connected:=True;
    end;

    SendMessage(hDBExplorer, EM_SETSEL, 0, -1);
    SendMessage(hDBExplorer,WM_COPY,0,0);
    if ClipBoard.GetTextBuf(Buf, BufSize)=BufSize then
      Raise Exception.Create('Source query must be under 2 kb');
    with Query1 do begin
      SQL.Text:= String(Buf);
      Open;
      First;
      If not EOF then begin
        List:= TStringList.Create;
        try
          for x:=0 to FieldCount-1 do begin
            Str1:= Str1+Fields[x].Fieldname;
            if x<>FieldCount-1 then Str1:=Str1+edtDelimiter.Text;
          end;
          List.Add(Str1);
          While not EOF do begin
            Str1:='';
            for x:=0 to FieldCount-1 do begin
              Str1:=Str1+Fields[x].AsString;
              if x<>FieldCount-1 then Str1:=Str1+edtDelimiter.Text;
            end;
            List.Add(Str1);
            Next;
          end;
          List.SaveToFile(ExtractFilePath(Paramstr(0))+'\Result.txt');
          WinExec(PChar(edtEditor.Filename+' '+
                        ExtractFilePath(Paramstr(0))+'\Result.txt'),
                  SW_SHOWNORMAL);
        finally
          List.Free;
        end;
      end else MessageDlg('No records Selected', mtInformation,[mbOK],0);
    end;
  except on E: Exception do
    MessageDlg(E.Message,mtError,[mbOK],0);
  end;
  Close;
end;

end.
